/*  mesg_en.h
 *
 *  copyright (c) 2000-2003 SeaD
 *  see GPL for copying info
 *
 */

#ifndef _MESG_H
#define _MESG_H 1

#define LANG            ""

#define CHNL_OUT        "[%s] out of channels %s\n"
#define CHNL_WELCOME    "[%s] %s join chat.\n"
#define CHNL_BYE        "[%s] %s leave chat.\n"
#define CHNL_JOIN       "[%s] %s join channel %s.\n"
#define CHNL_LEAVE      "[%s] %s leave channel %s.\n"
#define CHNL_JOINP      "[%s] %s join private.\n"
#define CHNL_LEAVEP     "[%s] %s leave private.\n"

#define CMND_HQUIT      "[%s] %s(%s,%s): quit %s.\n"
#define CMND_HHELP      "[%s] %s(%s,%s) [<command>]: help on commands.\n"
#define CMND_HVERSION   "[%s] %s(%s): dysplay version.\n"
#define CMND_HSTATUS    "[%s] %s(%s): show current status.\n"
#define CMND_HKEYS      "[%s] %s(%s): show working keys.\n"
#define CMND_HVERBOSE   "[%s] %s(%s): toggle verbosity.\n"
#define CMND_HCLEAR     "[%s] %s(%s): clear command and screen history.\n"
#define CMND_HSHELL     "[%s] %s [<command>]: shell command.\n"
#define CMND_HLOAD      "[%s] %s [<filename>]: load configuration file.\n"
#define CMND_HSAVE      "[%s] %s [<filename>]: save configuration file.\n"
#define CMND_HANSWER    "[%s] %s(%s) [<new autoanswer>]: show/change current autoanswer.\n"
#define CMND_HGENDER    "[%s] %s(%s): change gender.\n"
#define CMND_HMY        "[%s] %s: change sounds mode.\n"
#define CMND_HFAVORITE  "[%s] %s(%s) [<nick1> <nick2> ...]: show/favorite/unfavorite nick(s).\n"
#define CMND_HIGNORE    "[%s] %s(%s) [<nick1> <nick2> ...]: show/ignore/unignore nick(s).\n"
#define CMND_HBAN       "[%s] %s [<nick1> <nick2> ...]: show/ban/unban address(es).\n"
#define CMND_HBCAST     "[%s] %s toggle broadcast messages.\n"
#define CMND_HJOIN      "[%s] %s(%s) <channel>: join channel.\n"
#define CMND_HLEAVE     "[%s] %s(%s) [<channel>]: leave channel.\n"
#define CMND_HNICK      "[%s] %s(%s) <newnick>: change current nick.\n"
#define CMND_HMESG      "[%s] %s(%s,%s) <nick> <mesg>: send message to nick.\n"
#define CMND_HMASS      "[%s] %s <mesg>: send mass message.\n"
#define CMND_HEXEC      "[%s] %s <nick> <command>: execute command.\n"
#define CMND_HME        "[%s] %s [<action>]: me action.\n"
#define CMND_HTOPIC     "[%s] %s(%s) [<newtopic>]: show/change current topic.\n"
#define CMND_HADD       "[%s] %s [<addtopic>]: add to current topic.\n"
#define CMND_HMODE      "[%s] %s(%s) [<0-4>]: change current mode.\n"
#define CMND_HNORMAL    "[%s] %s(%s): change current mode to Normal.\n"
#define CMND_HDND       "[%s] %s(%s) [<new autoanswer>]: change current mode to DND.\n"
#define CMND_HAWAY      "[%s] %s(%s) [<new autoanswer>]: change current mode to Away.\n"
#define CMND_HOFF       "[%s] %s(%s) [<new autoanswer>]: change current mode to Offline.\n"
#define CMND_HINFO      "[%s] %s(%s,%s) [<nick1> <nick2> ...]: get info on nick(s).\n"
#define CMND_HBEEP      "[%s] %s(%s) [<nick1> <nick2> ...]: beep to nick(s).\n"
#define CMND_HTALK      "[%s] %s(%s,%s) <nick>: private chat with nick.\n"
#define CMND_HHERE      "[%s] %s: who here.\n"
#define CMND_HACTIVE    "[%s] %s: change current activity.\n"
#define CMND_HCOMMANDS  "[%s] available commands:\n"
#define CMND_HKEYWORK   "[%s] working keys:\n"
#define CMND_HKEY1      "F1-4 - switch to channel\n"
#define CMND_HKEY2      "^O or TAB - next channel\n"
#define CMND_HKEY3      "^D - exit chat\n"
#define CMND_HKEY4      "^A - change activity\n"
#define CMND_HKEY5      "^K - reverse users\n"
#define CMND_HKEY6      "^R or F5 - update users\n"
#define CMND_HKEY7      "^L - refresh screen\n"
#define CMND_HKEY8      "^T - top of screen history\n"
#define CMND_HKEY9      "^B - bottom of screen history\n"
#define CMND_HKEY0      "^P or PGUP - scroll screen up\n"
#define CMND_HKEYA      "^N or PGDN - scroll screen down\n"
#ifdef  CHARSET
# define CMND_HKEYB     "^E - recode input line after cursor\n"
#endif  /* CHARSET */
#define CMND_HKEYC      "'`' , [1-9] - put nick #[1-9] into input line\n"
#define CMND_HKEYD      "'/' , [1-9] - message to nick #[1-9]\n"
#define CMND_BCASTON    "[%s] broadcast on.\n"
#define CMND_BCASTOFF   "[%s] broadcast off.\n"
#define CMND_VERSION    "[%s] %s v%s%s (%s).\n"
#define CMND_STATUS     "[%s] current status:\n"
#define CMND_STATUSA    "addr: %s, port: %u, proto: %s\n"
#define CMND_STATUSL    "clients connected: %d\n"
#define CMND_VERBOSEON  "[%s] verbose on.\n"
#define CMND_VERBOSEOFF "[%s] verbose off.\n"
#define CMND_CLEAR      "[%s] channel cleared.\n"
#ifdef  SHELL
# define CMND_SHELL     "[%s] shell command:\n"
# define CMND_SHELLE    "[%s] shell command failed.\n"
#else   /* SHELL */
# define CMND_SHELLD    "[%s] /! command disabled.\n"
#endif  /* SHELL */
#define CMND_LOAD       "[%s] configuration loaded from:\n"
#define CMND_LOADF      "[%s] configuration load failed.\n"
#define CMND_SAVE       "[%s] configuration saved to:\n"
#define CMND_SAVEF      "[%s] configuration save failed.\n"
#define CMND_ANSDND     "[%s] DND autoanswer:\n"
#define CMND_ANSAWAY    "[%s] Away autoanswer:\n"
#define CMND_ANSOFF     "[%s] Offline autoanswer:\n"
#define CMND_GENDERM    "[%s] male gender.\n"
#define CMND_GENDERF    "[%s] female gender.\n"
#define CMND_BEEPALL    "[%s] play all beeps.\n"
#define CMND_BEEPCUR    "[%s] play current beeps only.\n"
#define CMND_FAVORITEN  "[%s] favorite nicks:\n"
#define CMND_FAVORITEI  "[%s] nick %s favored.\n"
#define CMND_FAVORITEU  "[%s] nick %s unfavored.\n"
#define CMND_IGNOREN    "[%s] ignored nicks:\n"
#define CMND_IGNOREI    "[%s] nick %s ignored.\n"
#define CMND_IGNOREU    "[%s] nick %s unignored.\n"
#define CMND_BANA       "[%s] banned addresses:\n"
#define CMND_BANB       "[%s] address %s banned.\n"
#define CMND_BANU       "[%s] address %s unbanned.\n"
#define CMND_INICK      "[%s] invalid nick %s\n"
#define CMND_ICHANNEL   "[%s] invalid channel %s\n"
#define CMND_LEAVE      "[%s] can't leave channel %s\n"
#define CMND_NICK       "[%s] nick %s already exists.\n"
#define CMND_MESG       "[%s] message to %s:\n"
#define CMND_MASS       "[%s] mass message:\n"
#define CMND_QTOPIC     "[%s] current topic:\n"
#define CMND_TOPIC      "[%s] current topic on %s:\n"
#define CMND_UNKNOWN    "[%s] unknown command: %s\n"

#define ECHAT_SIGNAL    "[%s] SIGNAL %d received, quit now.\n"
#define ECHAT_BYE       "[%s] bye, %s.\n"
#define ECHAT_WELCOME   "[%s] welcome to %s v%s, %s.\n"

#define PARS_NICK       "[%s] %s change nick to %s.\n"
#define PARS_MESG       "[%s] message from %s:\n"
#define PARS_MASS       "[%s] mass message from %s:\n"
#define PARS_MESGACK    "[%s] %s received message.\n"
#define PARS_MESGANS    "[%s] autoanswer from %s:\n"
#define PARS_EXEC       "[%s] exec from %s:\n"
#define PARS_EXECACK    "[%s] exec result from %s:\n"
#define PARS_QTOPIC     "[%s] new topic:\n"
#define PARS_TOPIC      "[%s] new topic on %s:\n"
#define PARS_QTOPICC    "[%s] current topic:\n"
#define PARS_TOPICC     "[%s] current topic on %s:\n"
#define PARS_MODE       "[%s] %s enter "
#define PARS_MODENORMAL "Normal mode.\n"
#define PARS_MODEDND    "DND mode:\n"
#define PARS_MODEAWAY   "Away mode:\n"
#define PARS_MODEOFF    "Offline mode:\n"
#define PARS_INFO       "[%s] info request from %s.\n"
#define PARS_INFORM     "[%s] info on %s:\n"
#define PARS_QINFOUH    "user: %s, host: %s, mem: %s, %s\n"
#define PARS_INFOUH     "user: %s, host: %s [%s]\n"
#define PARS_INFOCH     "channels: %s\n"
#define PARS_BEEP       "[%s] beep received from %s.\n"
#define PARS_BEEPACK    "[%s] beep sent to %s.\n"
#define PARS_HERE       "[%s] here %s (%s).\n"
#define PARS_HEREACT    "active"
#define PARS_HERENAC    "not active"

#define SOCK_ALLOC      "[%s] socket allocation failed.\n"
#define SOCK_ROUTE      "[%s] route failed to %s\n"
#define SOCK_RECV       "[%s] receive failed from %s\n"
#define SOCK_ADDRESS    "[%s] invalid address for %s: %s\n"
#define SOCK_USEND      "[%s] unicast send failed to %s\n"
#define SOCK_BSEND      "[%s] broadcast send failed to %s\n"

#define SOCK_TCONN      "[%s] client connected.\n"
#define SOCK_TWELCOME   "Welcome to eChat.\n"
#define SOCK_TOUT       "Out of clients.\n"

#define CMND_SCLEAR     "Channel cleared."
#define CMND_SLOAD      "Configuration loaded."
#define CMND_SLOADF     "Configuration load failed."
#define CMND_SSAVE      "Configuration saved."
#define CMND_SSAVEF     "Configuration save failed."
#define CMND_SGENDERM   "Male gender."
#define CMND_SGENDERF   "Female gender."
#define CMND_SBEEPALL   "Play all beeps."
#define CMND_SBEEPCUR   "Play current beeps only."
#define CMND_SUNKNOWN   "Unknown command."

#define TERM_SQUIT      "Quit."

#define MAKE_SCHAT      "Chat string sent."
#define MAKE_SNICK      "Nick changed."
#define MAKE_SMESG      "Message sent."
#define MAKE_SMASS      "Mass message sent."
#define MAKE_SME        "Me string sent."
#define MAKE_STOPIC     "New topic sent."
#define MAKE_SMODE      "Mode changed."
#define MAKE_SINFO      "Info sent."
#define MAKE_SBEEP      "Beep sent."
#define MAKE_SPRIVJOIN  "Private chat started."
#define MAKE_SPRIVLEAVE "Private chat closed."
#define MAKE_SPRIVCHAT  "Private chat string sent."
#define MAKE_SPRIVME    "Private me string sent."
#define MAKE_SHERE      "Here sent."
#define MAKE_SACTIVE    "Activity changed."

#define PARS_SHERE      "Who here received."
#define PARS_SBEEPREQ   "Message \"beepreq\" received."

#define SOCK_SROUTE     "Route failed."
#define SOCK_SRECEIVE   "Receive failed."
#define SOCK_SUSEND     "Unicast send failed."
#define SOCK_SBSEND     "Broadcast send failed."

#endif  /* _MESG_H */
