/*  pckt_pmke.c
 *
 *  copyright (c) 2000-2003 SeaD
 *  see GPL for copying info
 *
 */

#include <string.h>
#include <unistd.h>
#include "echat.h"
#include "pckt_ppak.h"

void make_pwelcome(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%u%c%u%c%u",
        MSG_PWELCOME,
        config->nick, MSG_SPLIT,
        1, MSG_SPLIT,           /* mode */
        1, MSG_SPLIT,           /* gender */
        1);                     /* channel ? */
}

void make_pbye(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%u",
        MSG_PBYE,
        config->nick, MSG_SPLIT,
        1);                     /* channel ? */
}

void make_pjoin(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%s%c%u",
        MSG_PJOIN,
        config->nick, MSG_SPLIT,
        status->nick, MSG_SPLIT,
        status->channel, MSG_SPLIT,
        1);                     /* mode || gender ? */
}

void make_pleave(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u",
        MSG_PLEAVE,
        status->channel, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        1);                     /* gender ? */
}

void make_pherewho(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s", 
        MSG_PHEREWHO,
        config->nick);
}

void make_phereim(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%u%c%s%c%u",
        MSG_PHEREIM,
        status->nick, MSG_SPLIT,
        1, MSG_SPLIT,           /* mode ? */
        config->nick, MSG_SPLIT,
        0);                     /* active ? */
}

void make_phere(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s", 
        MSG_PHEREWHO,
        config->nick);
}

void make_pchat(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%s",
        MSG_PCHAT,
        status->channel, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        buf);
}

void make_pme(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%s",
        MSG_PME,
        status->channel, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        buf);
}

void make_pmesg(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%s",
        MSG_PMESG,
        config->nick, MSG_SPLIT,
        status->nick, MSG_SPLIT,
        buf);
}

void make_pmass(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%s%s%c%s",
        MSG_PMASS,
        config->nick, MSG_SPLIT,
        "*Multiple*;", status->nick, ";", MSG_SPLIT,
        buf);
}

void make_pmesgack(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u%c%s%s%s%c%u",
        MSG_PMESGACK,
        config->nick, MSG_SPLIT,
        status->nick, MSG_SPLIT,
        1, MSG_SPLIT,           /* gender */
        (config->mode == MOD_DND) ? config->answer_dnd : "",
        (config->mode == MOD_AWAY) ? config->answer_away : "",
        (config->mode == MOD_OFF) ? config->answer_off : "",
        MSG_SPLIT,
        0);                     /* mode */
}

void make_ptopic(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s",
        MSG_PTOPIC,
        status->nick, MSG_SPLIT,
        status->chnl[chnl_getnum()].topic);
}

void make_ptopicnew(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s",
        MSG_PTOPICNEW,
        config->nick, MSG_SPLIT,
        status->room->topic);
}

void make_pprivjoin(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u",
        MSG_PPRIVJOIN,
        config->nick, MSG_SPLIT,
        status->channel, MSG_SPLIT,
        0);                     /* gender */
}

void make_pprivjoinack(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u",
        MSG_PPRIVJOINACK,
        config->nick, MSG_SPLIT,
        status->channel, MSG_SPLIT,
        0);                     /* gender */
}

void make_pprivleave(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u",
        MSG_PPRIVLEAVE,
        config->nick, MSG_SPLIT,
        status->channel, MSG_SPLIT,
        0);                     /* gender */
}

void make_pnick(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u%c%u",
        MSG_PNICK,
        status->nick, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        1, MSG_SPLIT,
        0);
}

void make_pmode(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%s%s%s%s%s%c%u%c%u",
        (config->mode == MOD_NORMAL) ? "1" : "",
        (config->mode == MOD_DND) ? "2" : "",
        (config->mode == MOD_AWAY) ? "3" : "",
        (config->mode == MOD_OFF) ? "4" : "",
        config->nick, MSG_SPLIT,
        1, MSG_SPLIT,           /* ??? */
        1);                     /* ??? */
}

void make_pactive(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%u%c%u",
        MSG_PACTIVE,
        config->nick, MSG_SPLIT,
        1, MSG_SPLIT,           /* ??? */
        config->active);
}

void make_pinfo(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s",
        MSG_PINFO,
        status->nick, MSG_SPLIT,
        config->nick);
}

void make_pinform(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%s%c%s%c%s%c%s%c%s%c%s%c%s%c%s%c%s%c%s",
        MSG_PINFORM,
        status->nick, MSG_SPLIT,
        "192.168.1.234", MSG_SPLIT,
        "523=760 KB", MSG_SPLIT,
        "47 %", MSG_SPLIT,
        "autoanswer", MSG_SPLIT,
        "userinfo", MSG_SPLIT,
        config->nick, MSG_SPLIT,
        "NBTHOST", MSG_SPLIT,
        "User ???", MSG_SPLIT,
        "* eChat *", MSG_SPLIT,
        "FreeBSD", MSG_SPLIT,
        "#Main ???");
}

void make_pbeep(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s",
        MSG_PBEEP,
        status->nick, MSG_SPLIT,
        config->nick);
}

void make_pbeepack(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u%c%u",
        MSG_PBEEPACK,
        status->nick, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        0, MSG_SPLIT,           /* ??? */
        0);                     /* gender */
}

void make_pexec(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%s%c%s",
        MSG_PEXEC,
        config->nick, MSG_SPLIT,
        status->nick, MSG_SPLIT,
        buf, MSG_SPLIT,
        "");
}

void make_pexecack(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u",
        MSG_PEXECACK,
        status->nick, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        3);                     /* ??? */
}

void make_pchnls(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s%c%u",
        MSG_PCHNLS,
        status->channel, MSG_SPLIT,
        config->nick, MSG_SPLIT,
        1);                     /* ??? */
}

void make_pchnlslist(void) {
    status->packet_len = snprintf(packet, MSG_SIZE, "%c%s%c%s",
        MSG_PCHNLSLIST,
        status->nick, MSG_SPLIT,
        "#Main");
}
